

!Bitmap class methodsFor: 'prompting'!

fromFileDialog
    "Bitmap fromFileDialog"
    | fileName bitmap |
    fileName := FileDialog new
        title: 'Bitmap file...';
        shareAware;
        addFilter: '*.*' description: 'All Files (*.*)';
        addFilter: '*.bmp' description: 'Bitmap Files (*.bmp)';
        fileSpec: '*.bmp';
        open;
        file.
    fileName isNil ifTrue: [^nil "cancelled"].
    CursorManager execute changeFor: [
        bitmap := Bitmap fromFile: fileName].
    (bitmap isKindOf: Bitmap) ifTrue: [^bitmap].
    (MessageBox confirm: 'This is not a bitmap file (*.bmp). Try again?')
        ifTrue: [^self fromFileDialog].
    ^nil! !

!Bitmap class methodsFor: 'converting'!

fromRGBArrays: arrays
    "An array of arrays; rows (one per y) of columns (one per x); each column is an instance of Color"
    | height width bits row base index color bitmap |
    height := arrays size. width := arrays first size.
    bits := ByteArray new: width * height * 3.
    1 to: height do: [:y |
        row := arrays at: y.
        base := (y - 1) * (3 * width).
        1 to: width do: [:x |
            color := row at: x.
            index := base + ((x - 1) * 3).
            bits at: index + 3 put: color red.
            bits at: index + 2 put: color green.
            bits at: index + 1 put: color blue]].
    bitmap := Bitmap new.
    bitmap bitmapInfo: (WinBitmapInfo 
        width: width height: height  planes: 1 bitCount: 24).
    bitmap createBitmap: bits.
    bitmap
        deviceContext: Bitmap memoryContext;
        graphicsTool: (Pen forDC: Bitmap memoryContext medium: bitmap).
    ^bitmap! !

!Bitmap methodsFor: 'converting'!
  
asRGBArrays
    "An array of arrays; rows (one per y) of columns (one per x); each column is an instance of Color"
    | bits base index red green blue |
    self bitCount = 24 ifFalse: [self error: 'Only 24-bit bitmaps handled'].
    bits := self getDIBits.
    ^(1 to: self height) collect: [:y |
        base := (y - 1) * (3 * self width).
        (1 to: self width) collect: [:x |
            index := base + ((x - 1) * 3).
            red := bits at: index + 3.
            green := bits at: index + 2.
            blue := bits at: index + 1.
            Color red: red green: green blue: blue]]! !
