
ViewManager subclass: #LightApplicator
  instanceVariableNames: 
    ' bitmap bitmapAsRGBArrays modifiedBitmap modifiedBitmapAsRGBArrays drawingPane ambientLighting lightBoundary externalLink '
  classVariableNames: ''
  poolDictionaries: 
    ' ColorConstants OperatingSystemConstants VirtualKeyConstants '
  category: 'JOOP5'
!


!LightApplicator class methodsFor: 'examples'!
  
example1
    "LightApplicator example1"
    self new open! !

!LightApplicator class methodsFor: 'window builder'!
  
wbBasicVersion

	"Private - Answer the WindowBuilder Pro version.
		Generated in: Visual Smalltalk 3.1.0 Win32"

	^3.1! !


!LightApplicator methodsFor: 'window builder'!
  
createMenus: aPane

	"WARNING!! This method was automatically generated by 
	WindowBuilder. Code you add here which does not conform to 
	the WindowBuilder API will probably be lost the next time 
	you save your layout definition."

	#generated.
	aPane menuWindow
	    yourself;
	    addMenu: (
	        Menu new
	            title: 'File';
	            owner: self;
	            appendItem: 'Open...' selector: #clickedFileOpen acceleratorString: '';
	            appendItem: 'Save...' selector: #clickedFileSave acceleratorString: ''
	    )!
 
createViews

    "WARNING!! This method was automatically generated by
    WindowBuilder. Code you add here which does not conform to
    the WindowBuilder API will probably be lost the next time
    you save your layout definition."

    | button1 button2 button3 entryField1 mainView staticText1
    xDU yDU |

    #generated.
    xDU := (SysFont width + 1 roundTo: 2) / 4.
    yDU := SysFont height / 8.
    mainView := self topPaneClass new.

        "Instance Variables"
    drawingPane := GraphPane new.

        "Temporary Variables"
    button1 := Button new.
    button2 := Button new.
    button3 := Button new.
    entryField1 := EntryField new.
    staticText1 := StaticText new.

    mainView
        owner: self;
        setName: 'mainView';
        when: #aboutToClose send: #finalize to: self;
        labelWithoutPrefix: ' Light Applicator';
        noSmalltalkMenuBar;
        backColor: Color gray;
        framingBlock:
            (LayoutFrame new
                leftRatio: 1/2; leftInset: -105 * xDU;
                topRatio: 1/2; topInset: -71 * yDU;
                rightRatio: 1/2; rightInset: -105 * xDU;
                bottomRatio: 1/2; bottomInset: -71 * yDU).
    self addView: mainView.

    drawingPane "GraphPane"
        owner: self;
        setName: 'drawingPane';
        when: #needsContents send: #updatePicture: to: self withArgument: drawingPane;
        framingBlock:
            (LayoutFrame new
                leftRatio: 0; leftInset: 12 * xDU;
                topRatio: 0; topInset: 12 * yDU;
                rightRatio: 0; rightInset: -110 * xDU;
                bottomRatio: 0; bottomInset: -108 * yDU);
        removeHorizontalScrollbarStyle;
        removeVerticalScrollbarStyle;
        startGroup;
        noTabStop;
        font: SysFont.
    mainView addSubpane: drawingPane.

    entryField1
        owner: self;
        when: #needsContents send: #updateAmbientLightingPane: to: self withArgument: entryField1;
        framingBlock:
            (LayoutFrame new
                leftRatio: 0; leftInset: 124 * xDU;
                topRatio: 0; topInset: 16 * yDU;
                rightRatio: 0; rightInset: -194 * xDU;
                bottomRatio: 0; bottomInset: -28 * yDU);
        startGroup;
        noTabStop;
        font: SysFont.
    mainView addSubpane: entryField1.

    staticText1
        owner: self;
        framingBlock:
            (LayoutFrame new
                leftRatio: 0; leftInset: 132 * xDU;
                topRatio: 0; topInset: 4 * yDU;
                rightRatio: 0; rightInset: -194 * xDU;
                bottomRatio: 0; bottomInset: -12 * yDU);
        contents: 'Ambient Lighting';
        startGroup;
        noTabStop;
        font: SysFont.
    mainView addSubpane: staticText1.

    button1
        owner: self;
        when: #clicked send: #clickedSelectArea to: self;
        framingBlock:
            (LayoutFrame new
                leftRatio: 0; leftInset: 122 * xDU;
                topRatio: 0; topInset: 38 * yDU;
                rightRatio: 0; rightInset: -198 * xDU;
                bottomRatio: 0; bottomInset: -54 * yDU);
        contents: 'Select Area';
        startGroup;
        noTabStop;
        font: SysFont.
    mainView addSubpane: button1.

    button2
        owner: self;
        when: #clicked send: #clickedIncreaseLighting to: self;
        framingBlock:
            (LayoutFrame new
                leftRatio: 0; leftInset: 122 * xDU;
                topRatio: 0; topInset: 62 * yDU;
                rightRatio: 0; rightInset: -198 * xDU;
                bottomRatio: 0; bottomInset: -78 * yDU);
        contents: 'Increase Lighting';
        startGroup;
        noTabStop;
        font: SysFont.
    mainView addSubpane: button2.

    button3
        owner: self;
        when: #clicked send: #clickedDecreaseLighting to: self;
        framingBlock:
            (LayoutFrame new
                leftRatio: 0; leftInset: 122 * xDU;
                topRatio: 0; topInset: 86 * yDU;
                rightRatio: 0; rightInset: -198 * xDU;
                bottomRatio: 0; bottomInset: -102 * yDU);
        contents: 'Decrease Lighting';
        startGroup;
        noTabStop;
        font: SysFont.
    mainView addSubpane: button3.

    self createMenus: mainView! !

!LightApplicator methodsFor: 'get/set'!
  
increaseAmbientLighting
    ambientLighting := (self ambientLighting + 0.05) min: 2.0!
 
decreaseAmbientLighting
    ambientLighting := (self ambientLighting - 0.05) max: 0.0!
 
ambientLighting
    ambientLighting isNil ifTrue: [ambientLighting := 0.5].
    ^ambientLighting! !

!LightApplicator methodsFor: 'opening/closing'!

finalize
    bitmap release.
    modifiedBitmap release.
    self wrapupDynamicLink.! !

!LightApplicator methodsFor: 'file event handling'!
   
clickedFileSave
    | fileName |
    fileName := (FileDialog new saveFile: '*.bmp') file.
    fileName isNil ifTrue: [^self "user cancelled"].
    modifiedBitmap outputToFile: fileName!
   
clickedFileOpen
    | newBitmap |
    newBitmap := Bitmap fromFileDialog.
    newBitmap isNil ifTrue: [^self]. "user cancelled"
    bitmap := newBitmap.
    bitmapAsRGBArrays := bitmap asRGBArrays.
    modifiedBitmap := bitmap clone.
    modifiedBitmapAsRGBArrays := bitmapAsRGBArrays collect: [:array |
        array collect: [:color | color shallowCopy]].
    lightBoundary := nil.
    self update! !

!LightApplicator methodsFor: 'light event handling'!

clickedSelectArea
    | area relativeArea |
    area := Display rectangleFromUser mapToWindow: drawingPane.
    relativeArea := area relativeTo: drawingPane boundingBox.
    lightBoundary := (Rectangle
        origin: relativeArea origin * bitmap extent
        extent: relativeArea extent * bitmap extent) truncated.
    self applyLighting; update!

clickedDecreaseLighting
    self decreaseAmbientLighting; applyLighting; update!
   
clickedIncreaseLighting
    self increaseAmbientLighting; applyLighting; update! !

!LightApplicator methodsFor: 'updating'!
 
updatePicture: aPane
    modifiedBitmap isNil ifTrue: [^self].
    aPane stretch: 1; bitmap: modifiedBitmap; showBitmap.!
 
update
    self mainView children do: [:child | child update]!
 
updateAmbientLightingPane: aPane
    aPane contents: self ambientLighting printString! !

!LightApplicator methodsFor: 'applying lighting'!
  
applyLighting
    | border color intensity |
    bitmap isNil ifTrue: [^self].
    lightBoundary isNil ifTrue: [^self].
    intensity := self ambientLighting.
    0 to: bitmap width - 1 do: [:x |
        0 to: bitmap height - 1 do: [:y |
            color := ((bitmapAsRGBArrays at: y + 1) at: x + 1) shallowCopy.
            (lightBoundary containsPoint: x@y) ifTrue: [
                color red: (((color red * intensity) truncated min: 255) max: 0).
                color green: (((color green * intensity) truncated min: 255) max: 0).
                color blue: (((color blue * intensity) truncated min: 255) max: 0)].
            (modifiedBitmapAsRGBArrays at: y + 1) at: x + 1 put: color]].
    modifiedBitmap release.
    modifiedBitmap :=  Bitmap fromRGBArrays: modifiedBitmapAsRGBArrays.
    self tickDynamicLink! !

!LightApplicator methodsFor: 'external renderer'!
   
setupDynamicLink
    | camera cubeFrames transformations extent |
    CanvasDLL setupPane: "Notifier activeWindow" Transcript mainView handle.
    CanvasLibrary setupRenderer. Float clearExceptionFlags.
    camera := Camera new renderingMode: #textureRendering.
    camera textureRenderer: SpanRenderer new.
    extent := CanvasLibrary getCanvasWidth@CanvasLibrary getCanvasHeight.
    camera changedScreenExtent: extent depth: ((extent x + extent y)/4) negated zScaling: 1.
    cubeFrames := Renderer example1Cubes.
    "Renderer examplePlaceCamera: camera."
    camera worldToCamera
        postTranslateBy: (Point3D x: 9.0 y: -3.0 z: 0.0).
    transformations := Array
        with: (Transformation4D rotatedByDegrees: (Point3D x: 0.0 y: 10.0 z: 0.0))
        with: (Transformation4D rotatedByDegrees: (Point3D x: 20.0 y: 0.0 z: 0.0))
        with: (Transformation4D rotatedByDegrees: (Point3D x: 30.0 y: 10.0 z: 0.0)).
    externalLink := Array with: camera with: cubeFrames with: transformations!
   
modifiedBitmapAsPicture
    | picturePointer color |
    bitmap isNil ifTrue: [^self].
    picturePointer := CanvasLibrary newPictureWidth: bitmap width height: bitmap height.
    CanvasLibrary lockPicture: picturePointer.
    0 to: bitmap width - 1 do: [:x |
        0 to: bitmap height - 1 do: [:y |
            color := (modifiedBitmapAsRGBArrays at: y + 1) at: x + 1.
            CanvasLibrary
                computePicture: picturePointer addressAt: x and: y;
                setPicture: picturePointer color: color red and: color green and: color blue]].
    CanvasLibrary unlockPicture: picturePointer.
    ^Picture add: (Picture new picturePointer: picturePointer)!
  
showDynamicLink
    externalLink groupDo: [:camera :cubeFrames :transformations |
        camera tick; beginRendering.
        cubeFrames with: transformations do: [:frame :t |
            frame localTransformation: t * frame localTransformation; invalidate.
            camera changedModel: frame transformation.
            frame facesDo: [:face | face render: camera]].
        camera beginLineRendering; endRendering.
        camera flip]!
 
tickDynamicLink
    | texture |
    externalLink isNil ifTrue: [self setupDynamicLink].
    texture := Texture new picture: self modifiedBitmapAsPicture.
    externalLink groupDo: [:camera :cubeFrames :transformations |
        cubeFrames last facesDo: [:face |
            face texture clearPicture. face texture: texture]].
    self showDynamicLink
!

wrapupDynamicLink
    externalLink isNil ifFalse: [
        externalLink groupDo: [:camera :cubeFrames :transformations |
            cubeFrames do: [:frame |
                frame facesDo: [:face | face texture picture finalize]]]].
    CanvasDLL wrapup
! !
LightApplicator comment: ''!
